Subject: Re: [PATCH net v4 2/2] xsk: Fix zero-copy AF_XDP fragment drop

From: Jakub Kicinski <[email-masked]>
Date: Fri, 20 Feb 2026 12:38:13 -0800

On Fri, 20 Feb 2026 13:37:09 +0100 Maciej Fijalkowski wrote:
> > Personal preference perhaps but removing error checking always
> > gives me pause. Maybe:
> > 
> > 	bool frag_fail;
> > 
> > 	frag_fail = __xsk_rcv_zc(xs, xskb, len, contd);
> > 	list_for_each...
> > 		...
> > 		frag_fail |= __xsk_rcv_zc(xs, xskb, len, contd);
> > 	DEBUG_NET_WARN_ON_ONCE(frag_fail);  
> 
> error checking can be actually skipped as xskq_prod_nb_free() peeked into
> xsk rx queue and told us there is enough space for descriptor production.

Understood. I was wondering whether the assert / DEBUG_NET.. may still
be worth keeping but up to you.

> Nikhil, I also see you routed the set to 'net' tree, previously xsk core
> was handled via bpf/bpf-next.

Dunno... We had mixed results, I think net / net-next is fine for stuff
that's purely packet movement. There is no BPF dependency here..
Unless you have a reason! I'm not feeling strongly. Just the stuff we
were fixing recently made me wonder if this code is getting sufficient
networking eyes..